// DMMFunc.cpp: implementation of the CDMMFunc class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "VC.h"
#include "DMMFunc.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CDMMFunc::CDMMFunc()
{
	memset(m_dmmInfo, 0, sizeof(DMM_INFO));
	m_dmmInfo[1] = m_dmmInfo[0];
	m_dmmInfo[2] = m_dmmInfo[1];
}

CDMMFunc::~CDMMFunc()
{

}
BOOL CDMMFunc::GetInfo(int id)		/*Get information from hardware*/
{
	DMMGetInfo(id, m_dmmInfo);
	m_dmmInfo[1] = m_dmmInfo[0];	
	return 0;
}

CString CDMMFunc::FormatValue(DMM_VALUE& dmmValue, BOOL bOverflow)
{
	CString szUnit[8] = {"p", "n", "u", "m", "K", "M", "G", ""};
	CString szType[4] = {"V", "A", "", "F"};
	CString sValue = "", s = "";

	if (bOverflow == 1)
	{
		sValue = "E";
	}
	else
	{
		if (dmmValue.iDotPos == 0)	//the point is at the end
		{
			sValue.Format("%d%d%d%d", 
				dmmValue.value[0], dmmValue.value[1], 
				dmmValue.value[2], dmmValue.value[3]);
		}
		else if (dmmValue.iDotPos == 1)
		{
			sValue.Format("%d.%d%d%d", 
				dmmValue.value[0], dmmValue.value[1], 
				dmmValue.value[2], dmmValue.value[3]);
		}
		else if (dmmValue.iDotPos == 2)
		{
			sValue.Format("%d%d.%d%d", 
				dmmValue.value[0], dmmValue.value[1], 
				dmmValue.value[2], dmmValue.value[3]);
		}
		else if (dmmValue.iDotPos == 3)
		{
			sValue.Format("%d%d%d.%d", 
				dmmValue.value[0], dmmValue.value[1], 
				dmmValue.value[2], dmmValue.value[3]);
		}
	}
	s.Format("%s", szUnit[dmmValue.iUnit]);
	sValue += s;
	s.Format("%s", szType[dmmValue.iUnitType]);
	sValue += s;
	
	if (dmmValue.iSign == DMM_SIGN_NEG)	//If the sign is negtive
	{
		sValue = "-" + sValue;
	}
	return sValue;
}
CString CDMMFunc::DMMFormatValue(DMM_INFO* pValue)
{
	return FormatValue(pValue->value, pValue->bOverflow);
}
CString CDMMFunc::DMMFormatRelValue(DMM_INFO* pValue)
{
	if (pValue->bRel == 0)
	{
		return "";
	}
	else
	{
		CString s = FormatValue(pValue->relValue, pValue->bOverflow);
		s = "REL: " + s;
		return s;
	}
}
int CDMMFunc::DMMGetType(int& bChange)
{
	bChange = !(m_dmmInfo[2].iType == m_dmmInfo[1].iType);
	m_dmmInfo[2].iType = m_dmmInfo[1].iType;
	return m_dmmInfo[2].iType;
}
int CDMMFunc::DMMGetDCAC()					//Get DC AC
{
	m_dmmInfo[2].iDCAC = m_dmmInfo[1].iDCAC;
	return m_dmmInfo[2].iDCAC;
}
int CDMMFunc::DMMGetAutoManual()
{
	m_dmmInfo[2].iMode = m_dmmInfo[1].iMode;
	return m_dmmInfo[2].iMode;
}
int CDMMFunc::DMMGetAMA()
{
	m_dmmInfo[2].bAma = m_dmmInfo[1].bAma;
	return m_dmmInfo[2].bAma;
}
int CDMMFunc::DMMGetRange(int& bChange)
{
	bChange = !(m_dmmInfo[2].iRange == m_dmmInfo[1].iRange);
	m_dmmInfo[2].iRange = m_dmmInfo[1].iRange;
	return m_dmmInfo[2].iRange;
}
BOOL CDMMFunc::DMMGetREL()
{
	m_dmmInfo[2].bRel = m_dmmInfo[1].bRel;
	return m_dmmInfo[2].bRel;
}