// DSODisT.cpp : implementation file
//

#include "stdafx.h"
#include "VC.h"
#include "DSODisT.h"

#include "memDC.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDSODisT

CDSODisT::CDSODisT()
{
	m_waveType = 0;
}

CDSODisT::~CDSODisT()
{
}


BEGIN_MESSAGE_MAP(CDSODisT, CStatic)
	//{{AFX_MSG_MAP(CDSODisT)
	ON_WM_SIZE()
	ON_WM_PAINT()
	ON_WM_ERASEBKGND()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDSODisT message handlers

void CDSODisT::OnSize(UINT nType, int cx, int cy) 
{
	CStatic::OnSize(nType, cx, cy);
	
	// TODO: Add your message handler code here
	ReconstructControl();
}

void CDSODisT::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	
	// TODO: Add your message handler code here
	GetClientRect (&m_rectCtrl);
	CMemDC memDC(&dc, &m_rectCtrl);
	if(m_dcBackground.GetSafeHdc()== NULL|| (m_bitmapBackground.m_hObject == NULL))
	{
		m_dcBackground.CreateCompatibleDC(&dc);
		m_bitmapBackground.CreateCompatibleBitmap(&dc, m_rectCtrl.Width(),m_rectCtrl.Height()) ;
		m_pBitmapOldBackground = m_dcBackground.SelectObject(&m_bitmapBackground) ;
		//DrawMeterBackground(&m_dcBackground, m_rectCtrl);

	}
	DrawView(&m_dcBackground, m_rectCtrl);
	memDC.BitBlt(0, 0, m_rectCtrl.Width(), m_rectCtrl.Height(), 
			           &m_dcBackground, 0, 0, SRCCOPY) ;

	// Do not call CStatic::OnPaint() for painting messages
}

BOOL CDSODisT::OnEraseBkgnd(CDC* pDC) 
{
	// TODO: Add your message handler code here and/or call default
	return FALSE;
	return CStatic::OnEraseBkgnd(pDC);
}
void CDSODisT::ReconstructControl()
{
	if ((m_pBitmapOldBackground) && 
		  (m_bitmapBackground.GetSafeHandle()) && 
			(m_dcBackground.GetSafeHdc()))
	{
			m_dcBackground.SelectObject(m_pBitmapOldBackground);
			m_dcBackground.DeleteDC() ;
			m_bitmapBackground.DeleteObject();
	}
	Invalidate ();
}
void CDSODisT::ReDraw()
{
	Invalidate();
}
void CDSODisT::DrawView(CDC* pDC, CRect& rc)
{
	pDC->FillSolidRect(&rc, RGB(0, 0, 0));
	CRect rcGrid(rc.left + 10, rc.top + 10, rc.right - 10, rc.bottom - 10);
	DrawGrid(pDC, rcGrid);
	DrawWave(pDC, rcGrid);
}
void CDSODisT::DrawGrid(CDC* pDC, CRect& rc)
{
	COLORREF PenColor(RGB(200,200,200)); 
	CPen CurrentPen(PS_SOLID,1,RGB(200, 200, 200));
	CPen* oldPen;
	oldPen = pDC->SelectObject(&CurrentPen);
	DrawGridScale(pDC,rc,RGB(200, 200, 200));//Draw grid Scale
	pDC->SelectObject(oldPen);
}
void CDSODisT::DrawGridScale(CDC*pDC,CRect Rect,COLORREF PenColor)
{
	int i,j,nMaxHScale,nMaxVScale,nShortScale,nLongScale;
	float x,y,xStep,yStep;
	struct {
		float x;
		float y;
	}ptCross;
	ptCross.x = 0;
	ptCross.y = 0;

	nMaxHScale = 60;
	nMaxVScale = 40;
	xStep = float(Rect.Width()*1.0/(nMaxHScale - 1));
	yStep = float(Rect.Height()*1.0/(nMaxVScale - 1));
//	xStep = yStep = float(Rect.Width()*1.0/nMaxHScale);

	
	nShortScale = int(xStep/3);
	nLongScale = int(xStep/2);

	x = Rect.left;
	y = Rect.top;
	for(i=0;i<(nMaxVScale/2);i++)
	{
		y = y + yStep;
	}
	ptCross.y = y;
	y = Rect.top;
	for(i=1;i<nMaxHScale;i++)
	{
		x = x + xStep;
		if(i == (nMaxHScale/2))
		{
			pDC->MoveTo(x,Rect.top);
			pDC->LineTo(x,Rect.bottom);
			ptCross.x = x;
		}
		else if(i%5==0 && i>=5)
		{
		
			pDC->MoveTo(x,y);
			pDC->LineTo(x,y+nLongScale);
			pDC->MoveTo(x,Rect.bottom);
			pDC->LineTo(x,Rect.bottom-nLongScale);
			for(j=1;j<nMaxVScale;j++)
			{
				y = y + yStep;
				pDC->SetPixel(x,y,PenColor);
			}
			y = Rect.top;	
		}
		else
		{
			pDC->MoveTo(x,y);
			pDC->LineTo(x,y+nShortScale);
			pDC->MoveTo(x,Rect.bottom);
			pDC->LineTo(x,Rect.bottom-nShortScale);
		}
		pDC->MoveTo(x,ptCross.y);
		pDC->LineTo(x,ptCross.y+nShortScale);
		pDC->MoveTo(x,ptCross.y);
		pDC->LineTo(x,ptCross.y-nShortScale);
	}
	x = Rect.left;
	y = Rect.top;
	for(i=1;i<nMaxVScale;i++)
	{
		y = y + yStep;
		if(i == (nMaxVScale/2))
		{
			pDC->MoveTo(Rect.left,y);
			pDC->LineTo(Rect.right,y);
		}
		else if(i%5==0 && i>=5)
		{
			pDC->MoveTo(x,y);
			pDC->LineTo(x+nLongScale,y);
			pDC->MoveTo(Rect.right,y);
			pDC->LineTo(Rect.right-nLongScale,y);
			for(j=1;j<nMaxHScale;j++)
			{
				x = x + xStep;
				pDC->SetPixel(x,y,PenColor);
			}
			x = Rect.left;
		}
		else
		{
			pDC->MoveTo(x,y);
			pDC->LineTo(x+nShortScale,y);
			pDC->MoveTo(Rect.right,y);
			pDC->LineTo(Rect.right-nShortScale,y);
		}
		pDC->MoveTo(ptCross.x,y);
		pDC->LineTo(ptCross.x+nShortScale,y);
		pDC->MoveTo(ptCross.x,y);
		pDC->LineTo(ptCross.x-nShortScale,y);
	}
	pDC->MoveTo(Rect.left, Rect.top);
	pDC->LineTo(Rect.right, Rect.top);
	pDC->LineTo(Rect.right, Rect.bottom);
	pDC->LineTo(Rect.left, Rect.bottom);
	pDC->LineTo(Rect.left, Rect.top);
}
void CDSODisT::DrawWave(CDC* pDC, CRect& rc)
{
	int i;
	COLORREF color[4] = {RGB(255, 255, 0), RGB(0, 255, 0), 
		RGB(0, 0, 255), RGB(0, 255, 255)};
	for (i = 0; i < 4; i++)
	{
		if (m_pHard->m_dsoFunc.m_dsoData[1].ch[i].enable == 0)
			continue;
		DrawWave(pDC, i, rc, color[i]);
	}
}
float CDSODisT::ChangeDataToDisplay(short data, CRect& rc)
{
	return rc.top + (rc.Height() - data * rc.Height() * 1.0 / 255);
}
void CDSODisT::DrawWave(CDC* pDC, int ch, CRect& rc, COLORREF cr)
{
	float xLeft, xSpace, x, y;
	int i;
	short* pData;
	BOOL bTmp = 0;
	xLeft = rc.left + rc.Width() * (m_pHard->m_dsoFunc.m_dsoData[1].display[ch].xDisLeft * 1.0 / 1000 / 300);
	xSpace = m_pHard->m_dsoFunc.m_dsoData[1].display[ch].xDotSpace * 1.0 / 1000 * ( rc.Width() * 1.0 / 300);

	CPen pen, *oldPen;
	pen.CreatePen(PS_SOLID, 1, cr);
	oldPen = pDC->SelectObject(&pen);
	
	pData = (short*)(m_pHard->m_dsoFunc.g_chData + ch);
	/*If has no data, return*/
	if (m_pHard->m_dsoFunc.m_dsoData[1].display[ch].nDisData == 0)
		return;

	
	//Normal
	if (m_pHard->m_dsoFunc.m_dsoData[1].display[ch].bDrawType == 1)
	{
		if (m_waveType == 0)	//line
		{			
			bTmp = 1;
			for (i = 0; i < m_pHard->m_dsoFunc.m_dsoData[1].display[ch].nDisData; i++)
			{		
				x = xLeft + i * xSpace;
				if (pData[i] == 0x7FFF)	
				{
					bTmp = 1;
					x += xSpace;
					continue;					
				}
				y = ChangeDataToDisplay(pData[i], rc);
				if (bTmp == 1)
				{
					pDC->MoveTo(x, y);		
					bTmp = 0;
				}
				pDC->LineTo(x, y);
			}
		}
		else
		{
			for (i = 0; i < m_pHard->m_dsoFunc.m_dsoData[1].display[i].nDisData; i++)
			{
				x = xLeft + i * xSpace;
				if (pData[i] == 0x7FFF)	
				{					
					continue;					
				}
				y = ChangeDataToDisplay(pData[i], rc);				
				pDC->SetPixel(x, y, cr);				
			}
		}
	}
	else
	{
		for (i = 0; i < m_pHard->m_dsoFunc.m_dsoData[1].display[i].nDisData; i++)
		{
			x = xLeft + i * xSpace;
			if (pData[i] == 0x7FFF)	
			{					
				continue;					
			}
			y = ChangeDataToDisplay(pData[i], rc);				
			pDC->SetPixel(x, y, cr);				
		}
	}


	pDC->SelectObject(oldPen);


}
