// DSOFunc.cpp: implementation of the CDSOFunc class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "VC.h"
#include "DSOFunc.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CDSOFunc::CDSOFunc()
{
	memset(m_dsoData+2, 0, sizeof(UPLOAD_DATA));
	m_dsoData[2].ch[0].vertPos = 150;
	m_dsoData[2].ch[0].vTrigPos = 150;
	m_dsoData[2].ch[0].voltDivIndex = 6;
	m_dsoData[2].ch[1].vertPos = 150;
	m_dsoData[2].ch[1].vTrigPos = 150;
	m_dsoData[2].ch[1].voltDivIndex = 6;
	m_dsoData[2].timebase = 12;
	m_dsoData[2].triggerMode = 0;
	m_dsoData[2].trigger[0].Source = 0;
}

CDSOFunc::~CDSOFunc()
{

}
BOOL CDSOFunc::GetInfo(int id)		/*Get information from hardware*/
{
	DSOGetAllSetting(id, m_dsoData, g_chData[0], g_chData[1], g_chData[2], g_chData[3]);
	m_dsoData[1] = m_dsoData[0];
	return 0;
}
int CDSOFunc::GetChPos(int ch, BOOL& bChange)
{
	bChange = !(m_dsoData[2].ch[ch].vertPos == m_dsoData[1].ch[ch].vertPos);
	m_dsoData[2].ch[ch].vertPos = m_dsoData[1].ch[ch].vertPos;
	return m_dsoData[2].ch[ch].vertPos;
}
int CDSOFunc::GetTrigPos(int ch, BOOL& bChange)
{
	bChange = !(m_dsoData[2].ch[ch].vTrigPos == m_dsoData[1].ch[ch].vTrigPos);
	m_dsoData[2].ch[ch].vTrigPos = m_dsoData[1].ch[ch].vTrigPos;
	return m_dsoData[2].ch[ch].vTrigPos;
}
int CDSOFunc::GetVoltage(int ch, BOOL& bChange)
{
	bChange = !(m_dsoData[2].ch[ch].voltDivIndex == m_dsoData[1].ch[ch].voltDivIndex);
	m_dsoData[2].ch[ch].voltDivIndex = m_dsoData[1].ch[ch].voltDivIndex;
	return m_dsoData[2].ch[ch].voltDivIndex;
}

int CDSOFunc::GetTimebase(BOOL& bChange)
{
	bChange = !(m_dsoData[2].timebase == m_dsoData[1].timebase);
	m_dsoData[2].timebase = m_dsoData[1].timebase;
	return m_dsoData[2].timebase;
}
int CDSOFunc::GetTrigSource(BOOL& bChange)
{
	bChange = !(m_dsoData[2].trigger[0].Source == m_dsoData[1].trigger[0].Source);
	m_dsoData[2].trigger[0].Source = m_dsoData[1].trigger[0].Source;
	return m_dsoData[2].trigger[0].Source;	
}
int CDSOFunc::GetTrigMode(BOOL& bChange)
{
	bChange = !(m_dsoData[2].triggerMode == m_dsoData[1].triggerMode);
	m_dsoData[2].triggerMode = m_dsoData[1].triggerMode;
	return m_dsoData[2].triggerMode;
}