// Hard.h: interface for the CHard class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_HARD_H__11FE68AD_3619_4382_8613_C11AC74932AA__INCLUDED_)
#define AFX_HARD_H__11FE68AD_3619_4382_8613_C11AC74932AA__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "DSOFunc.h"
#include "DMMFunc.h"

#include <deque>
using namespace std;

class CHard  
{
public:
	CHard();
	virtual ~CHard();

	BOOL SearchHardware();	/*search hardware*/
	void Process();			/*Hard control process*/
	/*Message process*/
	void InitMsgQueue();	/*Initalize message queue*/
	void PushMsg(DSO_MESSAGE msg);	/*push the message to the tail of the queue*/
	DSO_MESSAGE PopMsg();			/*popup the message at the front of the queue*/
	BOOL SetHardParam(int msg, int value);
	BOOL ProcessMsg(int id, DSO_MESSAGE msg);	/*process message*/
public:
	CDMMFunc m_dmmFunc;		/*DMM Function object*/
	CDSOFunc m_dsoFunc;		/*DSO function object*/

	/*Get information from hardware*/
private:	
	deque<DSO_MESSAGE> m_queMsg;	/*Message queue*/
	int m_iDevice;			/*hardware id*/
	BOOL m_bHard;			/*whether is demo or not, 0: demo, 1: not demo*/
	BOOL m_bConnect;		/*whether the hardware is connecting or not*/
	int m_iFunc;			/*function type*/
	BYTE m_usbStatus[MAX_DEV_NUM];	/*usb status*/
	HT_DEVICE_INFO m_devInfo;		/*Device Information*/
public:
	int GetDevice(){return m_iDevice;}
	BOOL isHard(){return m_bHard;}
	BOOL isConnect(){return m_bConnect;}
	int GetFunction(){return m_iFunc;}
	CString GetSerialNumber();			/*Get the serial number*/
};

#endif // !defined(AFX_HARD_H__11FE68AD_3619_4382_8613_C11AC74932AA__INCLUDED_)
